diff --git a/django/contrib/admin/options.py b/django/contrib/admin/options.py
index 5271e02..2825c99 100644
--- a/django/contrib/admin/options.py
+++ b/django/contrib/admin/options.py
@@ -11,6 +11,7 @@ from django.contrib import messages
 from django.views.decorators.csrf import csrf_protect
 from django.core.exceptions import PermissionDenied, ValidationError
 from django.core.paginator import Paginator
+from django.core.urlresolvers import reverse
 from django.db import models, transaction, router
 from django.db.models.related import RelatedObject
 from django.db.models.fields import BLANK_CHOICE_DASH, FieldDoesNotExist
@@ -776,9 +777,12 @@ class ModelAdmin(BaseModelAdmin):
             # redirect to the change-list page for this object. Otherwise,
             # redirect to the admin index.
             if self.has_change_permission(request, None):
-                post_url = '../'
+                post_url = reverse('admin:%s_%s_changelist' %
+                                   (opts.app_label, opts.module_name),
+                                   current_app=self.admin_site.name)
             else:
-                post_url = '../../../'
+                post_url = reverse('admin:index',
+                                   current_app=self.admin_site.name)
             return HttpResponseRedirect(post_url)
 
     def response_change(self, request, obj):
@@ -787,11 +791,14 @@ class ModelAdmin(BaseModelAdmin):
         """
         opts = obj._meta
 
-        # Handle proxy models automatically created by .only() or .defer()
+        # Handle proxy models automatically created by .only() or .defer().
+        # Refs #14529
         verbose_name = opts.verbose_name
+        module_name = opts.module_name
         if obj._deferred:
             opts_ = opts.proxy_for_model._meta
             verbose_name = opts_.verbose_name
+            module_name = opts_.module_name
 
         pk_value = obj._get_pk_val()
 
@@ -805,19 +812,28 @@ class ModelAdmin(BaseModelAdmin):
         elif "_saveasnew" in request.POST:
             msg = _('The %(name)s "%(obj)s" was added successfully. You may edit it again below.') % {'name': force_unicode(verbose_name), 'obj': obj}
             self.message_user(request, msg)
-            return HttpResponseRedirect("../%s/" % pk_value)
+            return HttpResponseRedirect(reverse('admin:%s_%s_change' %
+                                        (opts.app_label, module_name),
+                                        args=(pk_value,),
+                                        current_app=self.admin_site.name))
         elif "_addanother" in request.POST:
             self.message_user(request, msg + ' ' + (_("You may add another %s below.") % force_unicode(verbose_name)))
-            return HttpResponseRedirect("../add/")
+            return HttpResponseRedirect(reverse('admin:%s_%s_add' %
+                                        (opts.app_label, module_name),
+                                        current_app=self.admin_site.name))
         else:
             self.message_user(request, msg)
             # Figure out where to redirect. If the user has change permission,
             # redirect to the change-list page for this object. Otherwise,
             # redirect to the admin index.
             if self.has_change_permission(request, None):
-                return HttpResponseRedirect('../')
+                post_url = reverse('admin:%s_%s_changelist' %
+                                   (opts.app_label, module_name),
+                                   current_app=self.admin_site.name)
             else:
-                return HttpResponseRedirect('../../../')
+                post_url = reverse('admin:index',
+                                   current_app=self.admin_site.name)
+            return HttpResponseRedirect(post_url)
 
     def response_action(self, request, queryset):
         """
@@ -990,7 +1006,9 @@ class ModelAdmin(BaseModelAdmin):
             raise Http404(_('%(name)s object with primary key %(key)r does not exist.') % {'name': force_unicode(opts.verbose_name), 'key': escape(object_id)})
 
         if request.method == 'POST' and "_saveasnew" in request.POST:
-            return self.add_view(request, form_url='../add/')
+            return self.add_view(request, form_url=reverse('admin:%s_%s_add' %
+                                    (opts.app_label, opts.module_name),
+                                    current_app=self.admin_site.name))
 
         ModelForm = self.get_form(request, obj)
         formsets = []
@@ -1246,8 +1264,11 @@ class ModelAdmin(BaseModelAdmin):
             self.message_user(request, _('The %(name)s "%(obj)s" was deleted successfully.') % {'name': force_unicode(opts.verbose_name), 'obj': force_unicode(obj_display)})
 
             if not self.has_change_permission(request, None):
-                return HttpResponseRedirect("../../../../")
-            return HttpResponseRedirect("../../")
+                return HttpResponseRedirect(reverse('admin:index',
+                                                    current_app=self.admin_site.name))
+            return HttpResponseRedirect(reverse('admin:%s_%s_changelist' %
+                                        (opts.app_label, opts.module_name),
+                                        current_app=self.admin_site.name))
 
         object_name = force_unicode(opts.verbose_name)
 
@@ -1292,6 +1313,7 @@ class ModelAdmin(BaseModelAdmin):
             'module_name': capfirst(force_unicode(opts.verbose_name_plural)),
             'object': obj,
             'app_label': app_label,
+            'opts': opts,
         }
         context.update(extra_context or {})
         return TemplateResponse(request, self.object_history_template or [
diff --git a/django/contrib/admin/sites.py b/django/contrib/admin/sites.py
index 9bb9f4a..3a5c12b 100644
--- a/django/contrib/admin/sites.py
+++ b/django/contrib/admin/sites.py
@@ -339,9 +339,11 @@ class AdminSite(object):
                 # Check whether user has any perm for this module.
                 # If so, add the module to the model_list.
                 if True in perms.values():
+                    info = (app_label, model._meta.module_name)
                     model_dict = {
                         'name': capfirst(model._meta.verbose_name_plural),
-                        'admin_url': mark_safe('%s/%s/' % (app_label, model.__name__.lower())),
+                        'admin_url': reverse('admin:%s_%s_changelist' % info, current_app=self.name),
+                        'add_url': reverse('admin:%s_%s_add' % info, current_app=self.name),
                         'perms': perms,
                     }
                     if app_label in app_dict:
@@ -349,7 +351,7 @@ class AdminSite(object):
                     else:
                         app_dict[app_label] = {
                             'name': app_label.title(),
-                            'app_url': app_label + '/',
+                            'app_url': reverse('admin:app_list', kwargs={'app_label': app_label}, current_app=self.name),
                             'has_module_perms': has_module_perms,
                             'models': [model_dict],
                         }
@@ -383,9 +385,11 @@ class AdminSite(object):
                     # Check whether user has any perm for this module.
                     # If so, add the module to the model_list.
                     if True in perms.values():
+                        info = (app_label, model._meta.module_name)
                         model_dict = {
                             'name': capfirst(model._meta.verbose_name_plural),
-                            'admin_url': '%s/' % model.__name__.lower(),
+                            'admin_url': reverse('admin:%s_%s_changelist' % info, current_app=self.name),
+                            'add_url': reverse('admin:%s_%s_add' % info, current_app=self.name),
                             'perms': perms,
                         }
                         if app_dict:
diff --git a/django/contrib/admin/templatetags/admin_urls.py b/django/contrib/admin/templatetags/admin_urls.py
new file mode 100644
index 0000000..53dc65b
--- /dev/null
+++ b/django/contrib/admin/templatetags/admin_urls.py
@@ -0,0 +1,8 @@
+from django.core.urlresolvers import reverse, NoReverseMatch
+from django import template
+
+register = template.Library()
+
+@register.filter
+def admin_urlname(value, arg):
+    return 'admin:%s_%s_%s' % (value.app_label, value.module_name, arg)
diff --git a/django/contrib/admindocs/views.py b/django/contrib/admindocs/views.py
index 28319be..9725865 100644
--- a/django/contrib/admindocs/views.py
+++ b/django/contrib/admindocs/views.py
@@ -136,8 +136,7 @@ def view_index(request):
             site_obj = GenericSite()
         for (func, regex) in view_functions:
             views.append({
-                'name': getattr(func, '__name__', func.__class__.__name__),
-                'module': func.__module__,
+                'full_name': '%s.%s' % (func.__module__, getattr(func, '__name__', func.__class__.__name__)),
                 'site_id': settings_mod.SITE_ID,
                 'site': site_obj,
                 'url': simplify_regex(regex),
diff --git a/tests/regressiontests/admin_changelist/admin.py b/tests/regressiontests/admin_changelist/admin.py
new file mode 100644
index 0000000..9490cd5
--- /dev/null
+++ b/tests/regressiontests/admin_changelist/admin.py
@@ -0,0 +1,67 @@
+from django.core.paginator import Paginator
+from django.contrib import admin
+
+from models import (Child, Parent, Genre, Band, Musician, Group, Quartet,
+    Membership, ChordsMusician, ChordsBand, Invitation)
+
+site = admin.AdminSite(name="admin")
+
+class CustomPaginator(Paginator):
+    def __init__(self, queryset, page_size, orphans=0, allow_empty_first_page=True):
+        super(CustomPaginator, self).__init__(queryset, 5, orphans=2,
+            allow_empty_first_page=allow_empty_first_page)
+
+
+class ParentAdmin(admin.ModelAdmin):
+    list_filter = ['child__name']
+    search_fields = ['child__name']
+
+
+class ChildAdmin(admin.ModelAdmin):
+    list_display = ['name', 'parent']
+    list_per_page = 10
+
+    def queryset(self, request):
+        return super(ChildAdmin, self).queryset(request).select_related("parent__name")
+
+
+class CustomPaginationAdmin(ChildAdmin):
+    paginator = CustomPaginator
+
+
+class FilteredChildAdmin(admin.ModelAdmin):
+    list_display = ['name', 'parent']
+    list_per_page = 10
+
+    def queryset(self, request):
+        return super(FilteredChildAdmin, self).queryset(request).filter(
+            name__contains='filtered')
+
+
+class BandAdmin(admin.ModelAdmin):
+    list_filter = ['genres']
+
+
+class GroupAdmin(admin.ModelAdmin):
+    list_filter = ['members']
+
+
+class QuartetAdmin(admin.ModelAdmin):
+    list_filter = ['members']
+
+
+class ChordsBandAdmin(admin.ModelAdmin):
+    list_filter = ['members']
+
+
+class DynamicListDisplayChildAdmin(admin.ModelAdmin):
+    list_display = ('name', 'parent')
+
+    def get_list_display(self, request):
+        my_list_display = list(self.list_display)
+        if request.user.username == 'noparents':
+            my_list_display.remove('parent')
+
+        return my_list_display
+
+site.register(Child, DynamicListDisplayChildAdmin)
diff --git a/tests/regressiontests/admin_changelist/tests.py b/tests/regressiontests/admin_changelist/tests.py
index 09ec190..83ce6e3 100644
--- a/tests/regressiontests/admin_changelist/tests.py
+++ b/tests/regressiontests/admin_changelist/tests.py
@@ -3,7 +3,6 @@ from __future__ import with_statement
 from django.contrib import admin
 from django.contrib.admin.options import IncorrectLookupParameters
 from django.contrib.admin.views.main import ChangeList, SEARCH_VAR, ALL_VAR
-from django.core.paginator import Paginator
 from django.template import Context, Template
 from django.test import TestCase
 from django.test.client import RequestFactory
@@ -12,8 +11,14 @@ from django.contrib.auth.models import User
 from models import (Child, Parent, Genre, Band, Musician, Group, Quartet,
     Membership, ChordsMusician, ChordsBand, Invitation)
 
+from admin import (ChildAdmin, QuartetAdmin, BandAdmin, ChordsBandAdmin,
+    GroupAdmin, ParentAdmin, DynamicListDisplayChildAdmin, CustomPaginationAdmin,
+    FilteredChildAdmin, CustomPaginator, site as custom_site)
+
 
 class ChangeListTests(TestCase):
+    urls = "regressiontests.admin_changelist.urls"
+
     def setUp(self):
         self.factory = RequestFactory()
 
@@ -129,11 +134,7 @@ class ChangeListTests(TestCase):
             new_child = Child.objects.create(name='name %s' % i, parent=new_parent)
 
         request = self.factory.get('/child/')
-        m = ChildAdmin(Child, admin.site)
-        m.list_display = ['id', 'name', 'parent']
-        m.list_display_links = ['id']
-        m.list_editable = ['name']
-        m.paginator = CustomPaginator
+        m = CustomPaginationAdmin(Child, admin.site)
 
         cl = ChangeList(request, Child, m.list_display, m.list_display_links,
                 m.list_filter, m.date_hierarchy, m.search_fields,
@@ -330,8 +331,8 @@ class ChangeListTests(TestCase):
             request.user = user
             return request
 
+        m = custom_site._registry[Child]
         # Test with user 'noparents'
-        m = DynamicListDisplayChildAdmin(Child, admin.site)
         request = _mocked_authenticated_request(user_noparents)
         response = m.changelist_view(request)
         # XXX - Calling render here to avoid ContentNotRenderedError to be
@@ -340,15 +341,16 @@ class ChangeListTests(TestCase):
         self.assertNotContains(response, 'Parent object')
 
         # Test with user 'parents'
-        m = DynamicListDisplayChildAdmin(Child, admin.site)
         request = _mocked_authenticated_request(user_parents)
         response = m.changelist_view(request)
         # XXX - #15826
         response.render()
         self.assertContains(response, 'Parent object')
 
+        custom_site.unregister(Child)
         # Test default implementation
-        m = ChildAdmin(Child, admin.site)
+        custom_site.register(Child, ChildAdmin)
+        m = custom_site._registry[Child]
         request = _mocked_authenticated_request(user_noparents)
         response = m.changelist_view(request)
         # XXX - #15826
@@ -383,57 +385,3 @@ class ChangeListTests(TestCase):
         cl.get_results(request)
         self.assertEqual(len(cl.result_list), 10)
 
-
-class ParentAdmin(admin.ModelAdmin):
-    list_filter = ['child__name']
-    search_fields = ['child__name']
-
-
-class ChildAdmin(admin.ModelAdmin):
-    list_display = ['name', 'parent']
-    list_per_page = 10
-
-    def queryset(self, request):
-        return super(ChildAdmin, self).queryset(request).select_related("parent__name")
-
-
-class FilteredChildAdmin(admin.ModelAdmin):
-    list_display = ['name', 'parent']
-    list_per_page = 10
-
-    def queryset(self, request):
-        return super(FilteredChildAdmin, self).queryset(request).filter(
-            name__contains='filtered')
-
-
-class CustomPaginator(Paginator):
-    def __init__(self, queryset, page_size, orphans=0, allow_empty_first_page=True):
-        super(CustomPaginator, self).__init__(queryset, 5, orphans=2,
-            allow_empty_first_page=allow_empty_first_page)
-
-
-class BandAdmin(admin.ModelAdmin):
-    list_filter = ['genres']
-
-
-class GroupAdmin(admin.ModelAdmin):
-    list_filter = ['members']
-
-
-class QuartetAdmin(admin.ModelAdmin):
-    list_filter = ['members']
-
-
-class ChordsBandAdmin(admin.ModelAdmin):
-    list_filter = ['members']
-
-
-class DynamicListDisplayChildAdmin(admin.ModelAdmin):
-    list_display = ('name', 'parent')
-
-    def get_list_display(self, request):
-        my_list_display = list(self.list_display)
-        if request.user.username == 'noparents':
-            my_list_display.remove('parent')
-
-        return my_list_display
diff --git a/tests/regressiontests/admin_changelist/urls.py b/tests/regressiontests/admin_changelist/urls.py
new file mode 100644
index 0000000..1cbb496
--- /dev/null
+++ b/tests/regressiontests/admin_changelist/urls.py
@@ -0,0 +1,7 @@
+from django.conf.urls.defaults import *
+
+import admin
+
+urlpatterns = patterns('',
+    (r'^admin/', include(admin.site.urls)),
+)
diff --git a/tests/regressiontests/admin_custom_urls/__init__.py b/tests/regressiontests/admin_custom_urls/__init__.py
new file mode 100644
index 0000000..792d600
--- /dev/null
+++ b/tests/regressiontests/admin_custom_urls/__init__.py
@@ -0,0 +1 @@
+#
diff --git a/tests/regressiontests/admin_custom_urls/models.py b/tests/regressiontests/admin_custom_urls/models.py
new file mode 100644
index 0000000..f8c83a9
--- /dev/null
+++ b/tests/regressiontests/admin_custom_urls/models.py
@@ -0,0 +1,50 @@
+from functools import update_wrapper
+
+from django.contrib import admin
+from django.db import models
+
+
+class Action(models.Model):
+    name = models.CharField(max_length=50, primary_key=True)
+    description = models.CharField(max_length=70)
+
+    def __unicode__(self):
+        return self.name
+
+
+class ActionAdmin(admin.ModelAdmin):
+    """
+    A ModelAdmin for the Action model that changes the URL of the add_view
+    to '<app name>/<model name>/!add/'
+    The Action model has a CharField PK.
+    """
+
+    list_display = ('name', 'description')
+
+    def remove_url(self, name):
+        """
+        Remove all entries named 'name' from the ModelAdmin instance URL
+        patterns list
+        """
+        return filter(lambda e: e.name != name, super(ActionAdmin, self).get_urls())
+
+    def get_urls(self):
+        # Add the URL of our custom 'add_view' view to the front of the URLs
+        # list.  Remove the existing one(s) first
+        from django.conf.urls.defaults import patterns, url
+
+        def wrap(view):
+            def wrapper(*args, **kwargs):
+                return self.admin_site.admin_view(view)(*args, **kwargs)
+            return update_wrapper(wrapper, view)
+
+        info = self.model._meta.app_label, self.model._meta.module_name
+
+        view_name = '%s_%s_add' % info
+
+        return patterns('',
+            url(r'^!add/$', wrap(self.add_view), name=view_name),
+        ) + self.remove_url(view_name)
+
+
+admin.site.register(Action, ActionAdmin)
diff --git a/tests/regressiontests/admin_custom_urls/tests.py b/tests/regressiontests/admin_custom_urls/tests.py
new file mode 100644
index 0000000..cfc6b85
--- /dev/null
+++ b/tests/regressiontests/admin_custom_urls/tests.py
@@ -0,0 +1,72 @@
+from django.core.urlresolvers import reverse
+from django.template.response import TemplateResponse
+from django.test import TestCase
+
+from models import Action
+
+
+class AdminCustomUrlsTest(TestCase):
+    fixtures = ['users.json', 'actions.json']
+
+    def setUp(self):
+        self.client.login(username='super', password='secret')
+
+    def tearDown(self):
+        self.client.logout()
+
+    def testBasicAddGet(self):
+        """
+        A smoke test to ensure GET on the add_view works.
+        """
+        response = self.client.get('/custom_urls/admin/admin_custom_urls/action/!add/')
+        self.assertIsInstance(response, TemplateResponse)
+        self.assertEqual(response.status_code, 200)
+
+    def testAddWithGETArgs(self):
+        response = self.client.get('/custom_urls/admin/admin_custom_urls/action/!add/', {'name': 'My Action'})
+        self.assertEqual(response.status_code, 200)
+        self.assertTrue(
+            'value="My Action"' in response.content,
+            "Couldn't find an input with the right value in the response."
+        )
+
+    def testBasicAddPost(self):
+        """
+        A smoke test to ensure POST on add_view works.
+        """
+        post_data = {
+            '_popup': u'1',
+            "name": u'Action added through a popup',
+            "description": u"Description of added action",
+        }
+        response = self.client.post('/custom_urls/admin/admin_custom_urls/action/!add/', post_data)
+        self.assertEqual(response.status_code, 200)
+        self.assertContains(response, 'dismissAddAnotherPopup')
+        self.assertContains(response, 'Action added through a popup')
+
+    def testAdminUrlsNoClash(self):
+        """
+        Test that some admin URLs work correctly. The model has a CharField
+        PK and the add_view URL has been customized.
+        """
+        # Should get the change_view for model instance with PK 'add', not show
+        # the add_view
+        response = self.client.get('/custom_urls/admin/admin_custom_urls/action/add/')
+        self.assertEqual(response.status_code, 200)
+        self.assertContains(response, 'Change action')
+
+        # Ditto, but use reverse() to build the URL
+        path = reverse('admin:%s_action_change' % Action._meta.app_label,
+                args=('add',))
+        response = self.client.get(path)
+        self.assertEqual(response.status_code, 200)
+        self.assertContains(response, 'Change action')
+
+        # Should correctly get the change_view for the model instance with the
+        # funny-looking PK
+        path = reverse('admin:%s_action_change' % Action._meta.app_label,
+                args=("path/to/html/document.html",))
+        response = self.client.get(path)
+        self.assertEqual(response.status_code, 200)
+        self.assertContains(response, 'Change action')
+        self.assertContains(response, 'value="path/to/html/document.html"')
diff --git a/tests/regressiontests/admin_custom_urls/urls.py b/tests/regressiontests/admin_custom_urls/urls.py
new file mode 100644
index 0000000..6c2761a
--- /dev/null
+++ b/tests/regressiontests/admin_custom_urls/urls.py
@@ -0,0 +1,7 @@
+from django.conf.urls.defaults import *
+from django.contrib import admin
+
+urlpatterns = patterns('',
+    (r'^admin/', include(admin.site.urls)),
+)
+
diff --git a/tests/regressiontests/admin_inlines/admin.py b/tests/regressiontests/admin_inlines/admin.py
new file mode 100644
index 0000000..098d7b5
--- /dev/null
+++ b/tests/regressiontests/admin_inlines/admin.py
@@ -0,0 +1,118 @@
+from django.contrib import admin
+from django import forms
+
+from models import *
+
+site = admin.AdminSite(name="admin")
+
+
+class BookInline(admin.TabularInline):
+    model = Author.books.through
+
+
+class AuthorAdmin(admin.ModelAdmin):
+    inlines = [BookInline]
+
+
+class InnerInline(admin.StackedInline):
+    model = Inner
+    can_delete = False
+    readonly_fields = ('readonly',) # For bug #13174 tests.
+
+
+class HolderAdmin(admin.ModelAdmin):
+
+    class Media:
+        js = ('my_awesome_admin_scripts.js',)
+
+
+class InnerInline2(admin.StackedInline):
+    model = Inner2
+
+    class Media:
+        js = ('my_awesome_inline_scripts.js',)
+
+
+class InnerInline3(admin.StackedInline):
+    model = Inner3
+
+    class Media:
+        js = ('my_awesome_inline_scripts.js',)
+
+
+class TitleForm(forms.ModelForm):
+
+    def clean(self):
+        cleaned_data = self.cleaned_data
+        title1 = cleaned_data.get("title1")
+        title2 = cleaned_data.get("title2")
+        if title1 != title2:
+            raise forms.ValidationError("The two titles must be the same")
+        return cleaned_data
+
+
+class TitleInline(admin.TabularInline):
+    model = Title
+    form = TitleForm
+    extra = 1
+
+
+class Inner4StackedInline(admin.StackedInline):
+    model = Inner4Stacked
+
+
+class Inner4TabularInline(admin.TabularInline):
+    model = Inner4Tabular
+
+
+class Holder4Admin(admin.ModelAdmin):
+    inlines = [Inner4StackedInline, Inner4TabularInline]
+
+
+class InlineWeakness(admin.TabularInline):
+    model = ShoppingWeakness
+    extra = 1
+
+
+class QuestionInline(admin.TabularInline):
+    model = Question
+    readonly_fields=['call_me']
+
+    def call_me(self, obj):
+        return 'Callable in QuestionInline'
+
+
+class PollAdmin(admin.ModelAdmin):
+    inlines = [QuestionInline]
+
+    def call_me(self, obj):
+        return 'Callable in PollAdmin'
+
+
+class ChapterInline(admin.TabularInline):
+    model = Chapter
+    readonly_fields=['call_me']
+
+    def call_me(self, obj):
+        return 'Callable in ChapterInline'
+
+
+class NovelAdmin(admin.ModelAdmin):
+    inlines = [ChapterInline]
+
+
+site.register(TitleCollection, inlines=[TitleInline])
+# Test bug #12561 and #12778
+# only ModelAdmin media
+site.register(Holder, HolderAdmin, inlines=[InnerInline])
+# ModelAdmin and Inline media
+site.register(Holder2, HolderAdmin, inlines=[InnerInline2])
+# only Inline media
+site.register(Holder3, inlines=[InnerInline3])
+
+site.register(Poll, PollAdmin)
+site.register(Novel, NovelAdmin)
+site.register(Fashionista, inlines=[InlineWeakness])
+site.register(Holder4, Holder4Admin)
+site.register(Author, AuthorAdmin)
+
diff --git a/tests/regressiontests/admin_inlines/models.py b/tests/regressiontests/admin_inlines/models.py
index 8d9ca7c..f4e58f2 100644
--- a/tests/regressiontests/admin_inlines/models.py
+++ b/tests/regressiontests/admin_inlines/models.py
@@ -3,10 +3,9 @@ Testing of admin inline formsets.
 
 """
 from django.db import models
-from django.contrib import admin
 from django.contrib.contenttypes.models import ContentType
 from django.contrib.contenttypes import generic
-from django import forms
+
 
 class Parent(models.Model):
     name = models.CharField(max_length=50)
@@ -14,12 +13,14 @@ class Parent(models.Model):
     def __unicode__(self):
         return self.name
 
+
 class Teacher(models.Model):
     name = models.CharField(max_length=50)
 
     def __unicode__(self):
         return self.name
 
+
 class Child(models.Model):
     name = models.CharField(max_length=50)
     teacher = models.ForeignKey(Teacher)
@@ -31,20 +32,15 @@ class Child(models.Model):
     def __unicode__(self):
         return u'I am %s, a child of %s' % (self.name, self.parent)
 
+
 class Book(models.Model):
     name = models.CharField(max_length=50)
 
+
 class Author(models.Model):
     name = models.CharField(max_length=50)
     books = models.ManyToManyField(Book)
 
-class BookInline(admin.TabularInline):
-    model = Author.books.through
-
-class AuthorAdmin(admin.ModelAdmin):
-    inlines = [BookInline]
-
-admin.site.register(Author, AuthorAdmin)
 
 class Holder(models.Model):
     dummy = models.IntegerField()
@@ -56,12 +52,6 @@ class Inner(models.Model):
     readonly = models.CharField("Inner readonly label", max_length=1)
 
 
-class InnerInline(admin.StackedInline):
-    model = Inner
-    can_delete = False
-    readonly_fields = ('readonly',) # For bug #13174 tests.
-
-
 class Holder2(models.Model):
     dummy = models.IntegerField()
 
@@ -70,17 +60,6 @@ class Inner2(models.Model):
     dummy = models.IntegerField()
     holder = models.ForeignKey(Holder2)
 
-class HolderAdmin(admin.ModelAdmin):
-
-    class Media:
-        js = ('my_awesome_admin_scripts.js',)
-
-class InnerInline2(admin.StackedInline):
-    model = Inner2
-
-    class Media:
-        js = ('my_awesome_inline_scripts.js',)
-
 class Holder3(models.Model):
     dummy = models.IntegerField()
 
@@ -89,21 +68,6 @@ class Inner3(models.Model):
     dummy = models.IntegerField()
     holder = models.ForeignKey(Holder3)
 
-class InnerInline3(admin.StackedInline):
-    model = Inner3
-
-    class Media:
-        js = ('my_awesome_inline_scripts.js',)
-
-# Test bug #12561 and #12778
-# only ModelAdmin media
-admin.site.register(Holder, HolderAdmin, inlines=[InnerInline])
-# ModelAdmin and Inline media
-admin.site.register(Holder2, HolderAdmin, inlines=[InnerInline2])
-# only Inline media
-admin.site.register(Holder3, inlines=[InnerInline3])
-
-
 # Models for ticket #8190
 
 class Holder4(models.Model):
@@ -117,17 +81,6 @@ class Inner4Tabular(models.Model):
     dummy = models.IntegerField(help_text="Awesome tabular help text is awesome.")
     holder = models.ForeignKey(Holder4)
 
-class Inner4StackedInline(admin.StackedInline):
-    model = Inner4Stacked
-
-class Inner4TabularInline(admin.TabularInline):
-    model = Inner4Tabular
-
-class Holder4Admin(admin.ModelAdmin):
-    inlines = [Inner4StackedInline, Inner4TabularInline]
-
-admin.site.register(Holder4, Holder4Admin)
-
 
 # Models for #12749
 
@@ -145,12 +98,6 @@ class ShoppingWeakness(models.Model):
     fashionista = models.ForeignKey(Fashionista)
     item = models.ForeignKey(OutfitItem)
 
-class InlineWeakness(admin.TabularInline):
-    model = ShoppingWeakness
-    extra = 1
-
-admin.site.register(Fashionista, inlines=[InlineWeakness])
-
 # Models for #13510
 
 class TitleCollection(models.Model):
@@ -161,23 +108,6 @@ class Title(models.Model):
     title1 = models.CharField(max_length=100)
     title2 = models.CharField(max_length=100)
 
-class TitleForm(forms.ModelForm):
-
-    def clean(self):
-        cleaned_data = self.cleaned_data
-        title1 = cleaned_data.get("title1")
-        title2 = cleaned_data.get("title2")
-        if title1 != title2:
-            raise forms.ValidationError("The two titles must be the same")
-        return cleaned_data
-
-class TitleInline(admin.TabularInline):
-    model = Title
-    form = TitleForm
-    extra = 1
-
-admin.site.register(TitleCollection, inlines=[TitleInline])
-
 # Models for #15424
 
 class Poll(models.Model):
@@ -186,34 +116,9 @@ class Poll(models.Model):
 class Question(models.Model):
     poll = models.ForeignKey(Poll)
 
-class QuestionInline(admin.TabularInline):
-    model = Question
-    readonly_fields=['call_me']
-
-    def call_me(self, obj):
-        return 'Callable in QuestionInline'
-
-class PollAdmin(admin.ModelAdmin):
-    inlines = [QuestionInline]
-
-    def call_me(self, obj):
-        return 'Callable in PollAdmin'
-
 class Novel(models.Model):
     name = models.CharField(max_length=40)
 
 class Chapter(models.Model):
     novel = models.ForeignKey(Novel)
 
-class ChapterInline(admin.TabularInline):
-    model = Chapter
-    readonly_fields=['call_me']
-
-    def call_me(self, obj):
-        return 'Callable in ChapterInline'
-
-class NovelAdmin(admin.ModelAdmin):
-    inlines = [ChapterInline]
-
-admin.site.register(Poll, PollAdmin)
-admin.site.register(Novel, NovelAdmin)
diff --git a/tests/regressiontests/admin_inlines/urls.py b/tests/regressiontests/admin_inlines/urls.py
new file mode 100644
index 0000000..1cbb496
--- /dev/null
+++ b/tests/regressiontests/admin_inlines/urls.py
@@ -0,0 +1,7 @@
+from django.conf.urls.defaults import *
+
+import admin
+
+urlpatterns = patterns('',
+    (r'^admin/', include(admin.site.urls)),
+)
